# DOMElement Class Reference

By far the vast majority of objects (apart from text) that authors encounter when traversing a document are `DOMElement` nodes. More...

Inheritance diagram for DOMElement:

List of all members.

## Public Member Functions

Destructor
virtual | ~DOMElement ()
| Destructor.
Functions introduced in DOM Level 1
virtual const XMLCh * | getTagName () const =0
| The name of the element.
virtual const XMLCh * | getAttribute (const XMLCh *name) const =0
| Retrieves an attribute value by name.
virtual DOMAttr * | getAttributeNode (const XMLCh *name) const =0
| Retrieves an `DOMAttr` node by name.
virtual DOMNodeList * | getElementsByTagName (const XMLCh *name) const =0
| Returns a `DOMNodeList` of all descendant elements with a given tag name, in the order in which they would be encountered in a preorder traversal of the `DOMElement` tree.
virtual void | setAttribute (const XMLCh *name, const XMLCh *value)=0
| Adds a new attribute.
virtual DOMAttr * | setAttributeNode (DOMAttr *newAttr)=0
| Adds a new attribute.
virtual DOMAttr * | removeAttributeNode (DOMAttr *oldAttr)=0
| Removes the specified attribute node.
virtual void | removeAttribute (const XMLCh *name)=0
| Removes an attribute by name.
Functions introduced in DOM Level 2.
virtual const XMLCh * | getAttributeNS (const XMLCh *namespaceURI, const XMLCh *localName) const =0
| Retrieves an attribute value by local name and namespace URI.
virtual void | setAttributeNS (const XMLCh *namespaceURI, const XMLCh *qualifiedName, const XMLCh *value)=0
| Adds a new attribute.
virtual void | removeAttributeNS (const XMLCh *namespaceURI, const XMLCh *localName)=0
| Removes an attribute by local name and namespace URI.
virtual DOMAttr * | getAttributeNodeNS (const XMLCh *namespaceURI, const XMLCh *localName) const =0
| Retrieves an `DOMAttr` node by local name and namespace URI.
virtual DOMAttr * | setAttributeNodeNS (DOMAttr *newAttr)=0
| Adds a new attribute.
virtual DOMNodeList * | getElementsByTagNameNS (const XMLCh *namespaceURI, const XMLCh *localName) const =0
| Returns a `DOMNodeList` of all the `DOMElement`s with a given local name and namespace URI in the order in which they would be encountered in a preorder traversal of the `DOMDocument` tree, starting from this node.
virtual bool | hasAttribute (const XMLCh *name) const =0
| Returns `true` when an attribute with a given name is specified on this element or has a default value, `false` otherwise.
virtual bool | hasAttributeNS (const XMLCh *namespaceURI, const XMLCh *localName) const =0
| Returns `true` when an attribute with a given local name and namespace URI is specified on this element or has a default value, `false` otherwise.
Functions introduced in DOM Level 3
virtual void | setIdAttribute (const XMLCh *name, bool isId)=0
| If the parameter isId is `true`, this method declares the specified attribute to be a user-determined ID attribute.
virtual void | setIdAttributeNS (const XMLCh *namespaceURI, const XMLCh *localName, bool isId)=0
| If the parameter isId is `true`, this method declares the specified attribute to be a user-determined ID attribute.
virtual void | setIdAttributeNode (const DOMAttr *idAttr, bool isId)=0
| If the parameter isId is `true`, this method declares the specified attribute to be a user-determined ID attribute.
virtual const DOMTypeInfo * | getSchemaTypeInfo () const =0
| Returns the type information associated with this element.
Functions introduced in the ElementTraversal specification (http://www.w3.org/TR/2008/REC-ElementTraversal-20081222/)
virtual DOMElement * | getFirstElementChild () const =0
| The first child of type DOMElement.
virtual DOMElement * | getLastElementChild () const =0
| The last child of type DOMElement.
virtual DOMElement * | getPreviousElementSibling () const =0
| The previous sibling node of type DOMElement.
virtual DOMElement * | getNextElementSibling () const =0
| The next sibling node of type DOMElement.
virtual XMLSize_t | getChildElementCount () const =0
| The number of child nodes that are of type DOMElement.

## Protected Member Functions

Hidden constructors
| DOMElement ()
| DOMElement (const DOMElement &other)

## Detailed Description

By far the vast majority of objects (apart from text) that authors encounter when traversing a document are `DOMElement` nodes.

Assume the following XML document:<elementExample id="demo"> <subelement1/> <subelement2><subsubelement/></subelement2> </elementExample>

When represented using DOM, the top node is an `DOMElement` node for "elementExample", which contains two child `DOMElement` nodes, one for "subelement1" and one for "subelement2". "subelement1" contains no child nodes.

Elements may have attributes associated with them; since the `DOMElement` interface inherits from `DOMNode`, the generic `DOMNode` interface method `getAttributes` may be used to retrieve the set of all attributes for an element. There are methods on the `DOMElement` interface to retrieve either an `DOMAttr` object by name or an attribute value by name. In XML, where an attribute value may contain entity references, an `DOMAttr` object should be retrieved to examine the possibly fairly complex sub-tree representing the attribute value. On the other hand, in HTML, where all attributes have simple string values, methods to directly access an attribute value can safely be used as a convenience.

Since:
  DOM Level 1

It also defines the ElementTraversal helper interface defined by http://www.w3.org/TR/2008/REC-ElementTraversal-20081222/

## Constructor & Destructor Documentation

DOMElement::DOMElement | ( |  | ) | `[protected]`

DOMElement::DOMElement | ( | const DOMElement & | other | ) | `[protected]`

virtual DOMElement::~DOMElement | ( |  | ) | `[virtual]`

Destructor.

## Member Function Documentation

virtual const XMLCh* DOMElement::getTagName | ( |  | ) | const`[pure virtual]`

The name of the element.

For example, in: <elementExample id="demo"> ... </elementExample> , `tagName` has the value `"elementExample"`. Note that this is case-preserving in XML, as are all of the operations of the DOM.

Since:
  DOM Level 1

virtual const XMLCh* DOMElement::getAttribute | ( | const XMLCh * | name | ) | const`[pure virtual]`

Retrieves an attribute value by name.

Parameters:

  | name | The name of the attribute to retrieve.

Returns:
  The `DOMAttr` value as a string, or the empty string if that attribute does not have a specified or default value.

Since:
  DOM Level 1

virtual DOMAttr* DOMElement::getAttributeNode | ( | const XMLCh * | name | ) | const`[pure virtual]`

Retrieves an `DOMAttr` node by name.

Parameters:

  | name | The name (`nodeName`) of the attribute to retrieve.

Returns:
  The `DOMAttr` node with the specified name (`nodeName`) or `null` if there is no such attribute.

Since:
  DOM Level 1

virtual DOMNodeList* DOMElement::getElementsByTagName | ( | const XMLCh * | name | ) | const`[pure virtual]`

Returns a `DOMNodeList` of all descendant elements with a given tag name, in the order in which they would be encountered in a preorder traversal of the `DOMElement` tree.

Parameters:

  | name | The name of the tag to match on. The special value "*" matches all tags.

Returns:
  A list of matching `DOMElement` nodes.

Since:
  DOM Level 1

virtual void DOMElement::setAttribute | ( | const XMLCh * | name,
|  | const XMLCh * | value |
| ) |  |  | `[pure virtual]`

Adds a new attribute.

If an attribute with that name is already present in the element, its value is changed to be that of the value parameter. This value is a simple string, it is not parsed as it is being set. So any markup (such as syntax to be recognized as an entity reference) is treated as literal text, and needs to be appropriately escaped by the implementation when it is written out. In order to assign an attribute value that contains entity references, the user must create an `DOMAttr` node plus any `DOMText` and `DOMEntityReference` nodes, build the appropriate subtree, and use `setAttributeNode` to assign it as the value of an attribute.

Parameters:

  | name | The name of the attribute to create or alter.
  | value | Value to set in string form.

Exceptions:

  | DOMException | INVALID_CHARACTER_ERR: Raised if the specified name contains an illegal character. NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.

Since:
  DOM Level 1

virtual DOMAttr* DOMElement::setAttributeNode | ( | DOMAttr * | newAttr | ) | `[pure virtual]`

Adds a new attribute.

If an attribute with that name (`nodeName`) is already present in the element, it is replaced by the new one.

Parameters:

  | newAttr | The `DOMAttr` node to add to the attribute list.

Returns:
  If the `newAttr` attribute replaces an existing attribute, the replaced `DOMAttr` node is returned, otherwise `null` is returned.

Exceptions:

  | DOMException | WRONG_DOCUMENT_ERR: Raised if `newAttr` was created from a different document than the one that created the element. NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly. INUSE_ATTRIBUTE_ERR: Raised if `newAttr` is already an attribute of another `DOMElement` object. The DOM user must explicitly clone `DOMAttr` nodes to re-use them in other elements.

Since:
  DOM Level 1

virtual DOMAttr* DOMElement::removeAttributeNode | ( | DOMAttr * | oldAttr | ) | `[pure virtual]`

Removes the specified attribute node.

If the removed `DOMAttr` has a default value it is immediately replaced. The replacing attribute has the same namespace URI and local name, as well as the original prefix, when applicable.

Parameters:

  | oldAttr | The `DOMAttr` node to remove from the attribute list.

Returns:
  The `DOMAttr` node that was removed.

Exceptions:

  | DOMException | NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly. NOT_FOUND_ERR: Raised if `oldAttr` is not an attribute of the element.

Since:
  DOM Level 1

virtual void DOMElement::removeAttribute | ( | const XMLCh * | name | ) | `[pure virtual]`

Removes an attribute by name.

If the removed attribute is known to have a default value, an attribute immediately appears containing the default value as well as the corresponding namespace URI, local name, and prefix when applicable.
To remove an attribute by local name and namespace URI, use the `removeAttributeNS` method.

Parameters:

  | name | The name of the attribute to remove.

Exceptions:

  | DOMException | NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.

Since:
  DOM Level 1

virtual const XMLCh* DOMElement::getAttributeNS | ( | const XMLCh * | namespaceURI,
|  | const XMLCh * | localName |
| ) |  |  | const`[pure virtual]`

Retrieves an attribute value by local name and namespace URI.

Parameters:

  | namespaceURI | The namespace URI of the attribute to retrieve.
  | localName | The local name of the attribute to retrieve.

Returns:
  The `DOMAttr` value as a string, or an `null` if that attribute does not have a specified or default value.

Since:
  DOM Level 2

virtual void DOMElement::setAttributeNS | ( | const XMLCh * | namespaceURI,
|  | const XMLCh * | qualifiedName,
|  | const XMLCh * | value |
| ) |  |  | `[pure virtual]`

Adds a new attribute.

If an attribute with the same local name and namespace URI is already present on the element, its prefix is changed to be the prefix part of the `qualifiedName`, and its value is changed to be the `value` parameter. This value is a simple string, it is not parsed as it is being set. So any markup (such as syntax to be recognized as an entity reference) is treated as literal text, and needs to be appropriately escaped by the implementation when it is written out. In order to assign an attribute value that contains entity references, the user must create an `DOMAttr` node plus any `DOMText` and `DOMEntityReference` nodes, build the appropriate subtree, and use `setAttributeNodeNS` or `setAttributeNode` to assign it as the value of an attribute.

Parameters:

  | namespaceURI | The namespace URI of the attribute to create or alter.
  | qualifiedName | The qualified name of the attribute to create or alter.
  | value | The value to set in string form.

Exceptions:

  DOMException

  INVALID_CHARACTER_ERR: Raised if the specified qualified name contains an illegal character.
  NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.
  NAMESPACE_ERR: Raised if the `qualifiedName` is malformed, if the `qualifiedName` has a prefix and the `namespaceURI` is `null` or an empty string, if the `qualifiedName` has a prefix that is "xml" and the `namespaceURI` is different from "http://www.w3.org/XML/1998/namespace", if the `qualifiedName` has a prefix that is "xmlns" and the `namespaceURI` is different from "http://www.w3.org/2000/xmlns/", or if the `qualifiedName` is "xmlns" and the `namespaceURI` is different from "http://www.w3.org/2000/xmlns/".

Since:
  DOM Level 2

virtual void DOMElement::removeAttributeNS | ( | const XMLCh * | namespaceURI,
|  | const XMLCh * | localName |
| ) |  |  | `[pure virtual]`

Removes an attribute by local name and namespace URI.

If the removed attribute has a default value it is immediately replaced. The replacing attribute has the same namespace URI and local name, as well as the original prefix.

Parameters:

  | namespaceURI | The namespace URI of the attribute to remove.
  | localName | The local name of the attribute to remove.

Exceptions:

  | DOMException | NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.

Since:
  DOM Level 2

virtual DOMAttr* DOMElement::getAttributeNodeNS | ( | const XMLCh * | namespaceURI,
|  | const XMLCh * | localName |
| ) |  |  | const`[pure virtual]`

Retrieves an `DOMAttr` node by local name and namespace URI.

Parameters:

  | namespaceURI | The namespace URI of the attribute to retrieve.
  | localName | The local name of the attribute to retrieve.

Returns:
  The `DOMAttr` node with the specified attribute local name and namespace URI or `null` if there is no such attribute.

Since:
  DOM Level 2

virtual DOMAttr* DOMElement::setAttributeNodeNS | ( | DOMAttr * | newAttr | ) | `[pure virtual]`

Adds a new attribute.

If an attribute with that local name and namespace URI is already present in the element, it is replaced by the new one.

Parameters:

  | newAttr | The `DOMAttr` node to add to the attribute list.

Returns:
  If the `newAttr` attribute replaces an existing attribute with the same local name and namespace URI, the replaced `DOMAttr` node is returned, otherwise `null` is returned.

Exceptions:

  | DOMException | WRONG_DOCUMENT_ERR: Raised if `newAttr` was created from a different document than the one that created the element. NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly. INUSE_ATTRIBUTE_ERR: Raised if `newAttr` is already an attribute of another `DOMElement` object. The DOM user must explicitly clone `DOMAttr` nodes to re-use them in other elements.

Since:
  DOM Level 2

virtual DOMNodeList* DOMElement::getElementsByTagNameNS | ( | const XMLCh * | namespaceURI,
|  | const XMLCh * | localName |
| ) |  |  | const`[pure virtual]`

Returns a `DOMNodeList` of all the `DOMElement`s with a given local name and namespace URI in the order in which they would be encountered in a preorder traversal of the `DOMDocument` tree, starting from this node.

Parameters:

  | namespaceURI | The namespace URI of the elements to match on. The special value "*" matches all namespaces.
  | localName | The local name of the elements to match on. The special value "*" matches all local names.

Returns:
  A new `DOMNodeList` object containing all the matched `DOMElement`s.

Since:
  DOM Level 2

virtual bool DOMElement::hasAttribute | ( | const XMLCh * | name | ) | const`[pure virtual]`

Returns `true` when an attribute with a given name is specified on this element or has a default value, `false` otherwise.

Parameters:

  | name | The name of the attribute to look for.

Returns:
  `true` if an attribute with the given name is specified on this element or has a default value, `false` otherwise.

Since:
  DOM Level 2

virtual bool DOMElement::hasAttributeNS | ( | const XMLCh * | namespaceURI,
|  | const XMLCh * | localName |
| ) |  |  | const`[pure virtual]`

Returns `true` when an attribute with a given local name and namespace URI is specified on this element or has a default value, `false` otherwise.

HTML-only DOM implementations do not need to implement this method.

Parameters:

  | namespaceURI | The namespace URI of the attribute to look for.
  | localName | The local name of the attribute to look for.

Returns:
  `true` if an attribute with the given local name and namespace URI is specified or has a default value on this element, `false` otherwise.

Since:
  DOM Level 2

virtual void DOMElement::setIdAttribute | ( | const XMLCh * | name,
|  | bool | isId |
| ) |  |  | `[pure virtual]`

If the parameter isId is `true`, this method declares the specified attribute to be a user-determined ID attribute.

This affects the value of `DOMAttr::isId` and the behavior of `DOMDocument::getElementById`, but does not change any schema that may be in use, in particular this does not affect the `DOMAttr::getSchemaTypeInfo` of the specified DOMAttr node. Use the value `false` for the parameter isId to undeclare an attribute for being a user-determined ID attribute. To specify an `DOMAttr` by local name and namespace URI, use the setIdAttributeNS method.

Parameters:

  | name | The name of the `DOMAttr`.
  | isId | Whether the attribute is of type ID.

Exceptions:

  | DOMException | NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly. NOT_FOUND_ERR: Raised if the specified node is not an `DOMAttr` of this element.

Since:
  DOM Level 3

virtual void DOMElement::setIdAttributeNS | ( | const XMLCh * | namespaceURI,
|  | const XMLCh * | localName,
|  | bool | isId |
| ) |  |  | `[pure virtual]`

If the parameter isId is `true`, this method declares the specified attribute to be a user-determined ID attribute.

This affects the value of `DOMAttr::isId` and the behavior of `DOMDocument::getElementById`, but does not change any schema that may be in use, in particular this does not affect the `DOMAttr::getSchemaTypeInfo` of the specified DOMAttr node. Use the value `false` for the parameter isId to undeclare an attribute for being a user-determined ID attribute.

Parameters:

  | namespaceURI | The namespace URI of the `DOMAttr`.
  | localName | The local name of the `DOMAttr`.
  | isId | Whether the attribute is of type ID.

Exceptions:

  | DOMException | NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly. NOT_FOUND_ERR: Raised if the specified node is not an `DOMAttr` of this element.

Since:
  DOM Level 3

virtual void DOMElement::setIdAttributeNode | ( | const DOMAttr * | idAttr,
|  | bool | isId |
| ) |  |  | `[pure virtual]`

If the parameter isId is `true`, this method declares the specified attribute to be a user-determined ID attribute.

This affects the value of `DOMAttr::isId` and the behavior of `DOMDocument::getElementById`, but does not change any schema that may be in use, in particular this does not affect the `DOMAttr::getSchemaTypeInfo` of the specified DOMAttr node. Use the value `false` for the parameter isId to undeclare an attribute for being a user-determined ID attribute.

Parameters:

  | idAttr | The `DOMAttr` node.
  | isId | Whether the attribute is of type ID.

Exceptions:

  | DOMException | NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly. NOT_FOUND_ERR: Raised if the specified node is not an `DOMAttr` of this element.

Since:
  DOM Level 3

virtual const DOMTypeInfo* DOMElement::getSchemaTypeInfo | ( |  | ) | const`[pure virtual]`

Returns the type information associated with this element.

Returns:
  the `DOMTypeInfo` associated with this element

Since:
  DOM level 3

virtual DOMElement* DOMElement::getFirstElementChild | ( |  | ) | const`[pure virtual]`

The first child of type DOMElement.

Returns:
  The `DOMElement` object that is the first element node among the child nodes of this node, or `null` if there is none.

virtual DOMElement* DOMElement::getLastElementChild | ( |  | ) | const`[pure virtual]`

The last child of type DOMElement.

Returns:
  The `DOMElement` object that is the last element node among the child nodes of this node, or `null` if there is none.

virtual DOMElement* DOMElement::getPreviousElementSibling | ( |  | ) | const`[pure virtual]`

The previous sibling node of type DOMElement.

Returns:
  The `DOMElement` object that is the previous sibling element node in document order, or `null` if there is none.

virtual DOMElement* DOMElement::getNextElementSibling | ( |  | ) | const`[pure virtual]`

The next sibling node of type DOMElement.

Returns:
  The `DOMElement` object that is the next sibling element node in document order, or `null` if there is none.

virtual XMLSize_t DOMElement::getChildElementCount | ( |  | ) | const`[pure virtual]`

The number of child nodes that are of type DOMElement.

Note: the count is computed every time this function is invoked

Returns:
  The number of `DOMElement` objects that are direct children of this object (nested elements are not counted), or `0` if there is none.

The documentation for this class was generated from the following file:

- DOMElement.hpp